#  STR721.defn.tcl

proc {Add_Struck STR721_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]
   set A24addrbase [second $addressinfo]
#   set A32addrbase [third $addressinfo]
#   set interruptlevel [fourth $addressinfo]
#   set interruptvector [fifth $addressinfo]

   set CurrentVMEServer  $server
 
   for {set i 0} {$i < 8} {incr i} {
      define-vme-register $name xVME c$i.control  "-a$A24addrbase -w24 -o[expr 0x20 + ($i * 2)] -prw -d16 -zx"
      define-vme-register $name xVME c$i.data     "-a$A24addrbase -w24 -o[expr 0x30 + ($i * 2)] -prw -d16 -zd"
   }
}


set str721_counter_mode(1) 0x0128
set str721_counter_mode(2) 0x0028
set str721_counter_mode(3) 0x0328
set str721_counter_mode(4) 0x0028
set str721_counter_mode(5) 0x0d28

proc {Struck STR721_DAQ-reset} {args} {
#   STR721
    global CurrentVMEServer EGallow EGreport
    global str721_counter_mode
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.c0.control] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff

   set EGreport_save $EGreport
   set EGreport -1
   set-busy
   set-footer "resetting module $module"

#     reset all the AMD9513 chips on the module
#  master reset
         write-vme-registers $module.c?.control 0xffff
#  LOAD all counters
         write-vme-registers $module.c?.control 0xff5f
#  set data pointer register to a valid code
         write-vme-registers $module.c?.control 0xff01
#  set MM13 - enter 16bit bus mode          
         write-vme-registers $module.c?.control 0xffef
#  set MM14 - disable data pointer sequencing         
         write-vme-registers $module.c?.control 0xffe8

#    configure the 5 counters on each chip to act as 2 32-bit counters  (the 5th counter is not in fact used)
        for {set j 1} {$j <= 5} {incr j} {
#         set the data pointer register to the mode register for counter j
             write-vme-registers $module.c?.control [expr 0xff00 + $j]
#         set the mode register
             write-vme-registers $module.c?.data $str721_counter_mode($j)
#         set the data pointer register to the load register for counter j
             write-vme-registers $module.c?.control [expr 0xff08 + $j]
#         set the load register to 0
             write-vme-registers $module.c?.data 0
#         set the data pointer register to the hold register for counter j
             write-vme-registers $module.c?.control [expr 0xff10 + $j]
       }

   set EGreport $EGreport_save
   clear-busy
   clear-footer
}

proc {Struck STR721_DAQ-go} {args} {
#   STR721
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#    arm all counters in this chip
    write-vme-registers $module.c?.control 0xff2f
}

proc {Struck STR721_DAQ-halt} {args} {
#   STR721
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#    disarm all counters in this chip
    write-vme-registers $module.c?.control 0xffcf
}

proc {Struck STR721_DAQ-setup} {args} {
#   STR721
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

#   for parameter save/restore
set {Struck STR721_registersavepatterns} {}


